Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit
      
Public Declare Function SetWindowLong Lib "user32" Alias _
       "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
       As Long, ByVal dwNewLong As Long) As Long

Public Declare Function GetWindowRect Lib "user32" (ByVal _
       hwnd As Long, lpRect As Rect) As Long

Public Declare Function GetParent Lib "user32" (ByVal _
       hwnd As Long) As Long
       
Public Declare Function SetParent Lib "user32" (ByVal _
       hWndChild As Long, ByVal hWndNewParent As Long) _
       As Long
       
Public Declare Function SetWindowPos Lib "user32" (ByVal _
       hwnd As Long, ByVal hWndInsertAfter As Long, ByVal _
       X As Long, ByVal Y As Long, ByVal cx As Long, _
       ByVal cy As Long, ByVal wFlags As Long) As Long
       
Public Declare Function SetWindowsHookEx Lib "user32" Alias _
       "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, _
       ByVal hmod As Long, ByVal dwThreadId As Long) As Long
       
Public Declare Function UnhookWindowsHookEx Lib "user32" _
       (ByVal hHook As Long) As Long
       
Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type CWPSTRUCT
    lParam As Long
    wParam As Long
    Message As Long
    hwnd As Long
End Type

Private Const WM_MOVE As Long = &H3&
Private Const WM_SETCURSOR As Long = &H20&
Private Const WM_NCPAINT As Long = &H85&
Private Const WM_COMMAND As Long = &H111&

Private Const SWP_FRAMECHANGED As Long = &H20&
Private Const GWL_EXSTYLE As Long = -20&

Private WHook As Long

Public Sub Init()
    WHook = SetWindowsHookEx(4, AddressOf HookProc, 0, App.ThreadID)
    Call SetWindowLong(Form1.Command1.hwnd, GWL_EXSTYLE, &H80)
    Call SetParent(Form1.Command1.hwnd, GetParent(Form1.hwnd))
    Call SetWindowLong(Form1.Command2.hwnd, GWL_EXSTYLE, &H80)
    Call SetParent(Form1.Command2.hwnd, GetParent(Form1.hwnd))
    Call SetWindowLong(Form1.Command3.hwnd, GWL_EXSTYLE, &H80)
    Call SetParent(Form1.Command3.hwnd, GetParent(Form1.hwnd))
End Sub

Public Sub Terminate()
    Call UnhookWindowsHookEx(WHook)
    Call SetParent(Form1.Command1.hwnd, Form1.hwnd)
    Call SetParent(Form1.Command2.hwnd, Form1.hwnd)
    Call SetParent(Form1.Command3.hwnd, Form1.hwnd)
End Sub

Public Function HookProc(ByVal nCode As Long, ByVal wParam As Long, _
                          Inf As CWPSTRUCT) As Long
    Dim R As Rect
    Static LastParam As Long
    
    If Inf.hwnd = Form1.hwnd Then
        If Inf.Message = WM_NCPAINT Or Inf.Message = WM_MOVE Then
            Call GetWindowRect(Form1.hwnd, R)
            Call SetWindowPos(Form1.Command1.hwnd, 0, R.Right - 111, _
                          R.Top + 6, 17, 14, SWP_FRAMECHANGED)
                          
            Call SetWindowPos(Form1.Command2.hwnd, 0, R.Right - 93, _
                          R.Top + 6, 17, 14, SWP_FRAMECHANGED)
                          
            Call SetWindowPos(Form1.Command3.hwnd, 0, R.Right - 75, _
                          R.Top + 6, 17, 14, SWP_FRAMECHANGED)
        End If
    End If
End Function
